using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using ZXDT.DBUtility;

namespace ZXDT.CallCenter.DAL
{
    /// <summary>
    /// 数据访问类:T_Com_LogAction
    /// </summary>
    public partial class T_Com_LogAction
    {
        public T_Com_LogAction()
        { }
        #region  BasicMethod

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(string Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Com_LogAction");
            strSql.Append(" where Id=@Id ");
            SqlParameter[] parameters = {
                    new SqlParameter("@Id", SqlDbType.Char,32)          };
            parameters[0].Value = Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public bool Add(ZXDT.CallCenter.Model.T_Com_LogAction model)
        {
            if (string.IsNullOrEmpty(model.Id))
                model.Id = Guid.NewGuid().ToString().Replace("-","");
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Com_LogAction(");
            strSql.Append("Id,AddUser,AddUserId,ActionName,ActionUrl,Atime,ContentOld,ContentNew,TableName,TableId)");
            strSql.Append(" values (");
            strSql.Append("@Id,@AddUser,@AddUserId,@ActionName,@ActionUrl,@Atime,@ContentOld,@ContentNew,@TableName,@TableId)");
            SqlParameter[] parameters = {
                    new SqlParameter("@Id", SqlDbType.Char,32),
                    new SqlParameter("@AddUser", SqlDbType.VarChar,50),
                    new SqlParameter("@AddUserId", SqlDbType.Int,4),
                    new SqlParameter("@ActionName", SqlDbType.VarChar,50),
                    new SqlParameter("@ActionUrl", SqlDbType.VarChar,500),
                    new SqlParameter("@Atime", SqlDbType.DateTime),
                    new SqlParameter("@ContentOld", SqlDbType.Text),
                    new SqlParameter("@ContentNew", SqlDbType.Text),
                    new SqlParameter("@TableName", SqlDbType.VarChar,50),
                    new SqlParameter("@TableId", SqlDbType.VarChar,50)};
            parameters[0].Value = model.Id;
            parameters[1].Value = model.AddUser;
            parameters[2].Value = model.AddUserId;
            parameters[3].Value = model.ActionName;
            parameters[4].Value = model.ActionUrl;
            parameters[5].Value = model.Atime;
            parameters[6].Value = model.ContentOld;
            parameters[7].Value = model.ContentNew;
            parameters[8].Value = model.TableName;
            parameters[9].Value = model.TableId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(ZXDT.CallCenter.Model.T_Com_LogAction model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Com_LogAction set ");
            strSql.Append("AddUser=@AddUser,");
            strSql.Append("AddUserId=@AddUserId,");
            strSql.Append("ActionName=@ActionName,");
            strSql.Append("ActionUrl=@ActionUrl,");
            strSql.Append("Atime=@Atime,");
            strSql.Append("ContentOld=@ContentOld,");
            strSql.Append("ContentNew=@ContentNew,");
            strSql.Append("TableName=@TableName,");
            strSql.Append("TableId=@TableId");
            strSql.Append(" where Id=@Id ");
            SqlParameter[] parameters = {
                    new SqlParameter("@AddUser", SqlDbType.VarChar,50),
                    new SqlParameter("@AddUserId", SqlDbType.Int,4),
                    new SqlParameter("@ActionName", SqlDbType.VarChar,50),
                    new SqlParameter("@ActionUrl", SqlDbType.VarChar,500),
                    new SqlParameter("@Atime", SqlDbType.DateTime),
                    new SqlParameter("@ContentOld", SqlDbType.Text),
                    new SqlParameter("@ContentNew", SqlDbType.Text),
                    new SqlParameter("@TableName", SqlDbType.VarChar,50),
                    new SqlParameter("@TableId", SqlDbType.VarChar,50),
                    new SqlParameter("@Id", SqlDbType.Char,32)};
            parameters[0].Value = model.AddUser;
            parameters[1].Value = model.AddUserId;
            parameters[2].Value = model.ActionName;
            parameters[3].Value = model.ActionUrl;
            parameters[4].Value = model.Atime;
            parameters[5].Value = model.ContentOld;
            parameters[6].Value = model.ContentNew;
            parameters[7].Value = model.TableName;
            parameters[8].Value = model.TableId;
            parameters[9].Value = model.Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(string Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Com_LogAction ");
            strSql.Append(" where Id=@Id ");
            SqlParameter[] parameters = {
                    new SqlParameter("@Id", SqlDbType.Char,32)          };
            parameters[0].Value = Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Com_LogAction ");
            strSql.Append(" where Id in (" + Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public ZXDT.CallCenter.Model.T_Com_LogAction GetModel(string Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 Id,AddUser,AddUserId,ActionName,ActionUrl,Atime,ContentOld,ContentNew,TableName,TableId from T_Com_LogAction ");
            strSql.Append(" where Id=@Id ");
            SqlParameter[] parameters = {
                    new SqlParameter("@Id", SqlDbType.Char,32)          };
            parameters[0].Value = Id;

            ZXDT.CallCenter.Model.T_Com_LogAction model = new ZXDT.CallCenter.Model.T_Com_LogAction();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public ZXDT.CallCenter.Model.T_Com_LogAction DataRowToModel(DataRow row)
        {
            ZXDT.CallCenter.Model.T_Com_LogAction model = new ZXDT.CallCenter.Model.T_Com_LogAction();
            if (row != null)
            {
                if (row["Id"] != null)
                {
                    model.Id = row["Id"].ToString();
                }
                if (row["AddUser"] != null)
                {
                    model.AddUser = row["AddUser"].ToString();
                }
                if (row["AddUserId"] != null && row["AddUserId"].ToString() != "")
                {
                    model.AddUserId = int.Parse(row["AddUserId"].ToString());
                }
                if (row["ActionName"] != null)
                {
                    model.ActionName = row["ActionName"].ToString();
                }
                if (row["ActionUrl"] != null)
                {
                    model.ActionUrl = row["ActionUrl"].ToString();
                }
                if (row["Atime"] != null && row["Atime"].ToString() != "")
                {
                    model.Atime = DateTime.Parse(row["Atime"].ToString());
                }
                if (row["ContentOld"] != null)
                {
                    model.ContentOld = row["ContentOld"].ToString();
                }
                if (row["ContentNew"] != null)
                {
                    model.ContentNew = row["ContentNew"].ToString();
                }
                if (row["TableName"] != null)
                {
                    model.TableName = row["TableName"].ToString();
                }
                if (row["TableId"] != null)
                {
                    model.TableId = row["TableId"].ToString();
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select Id,AddUser,AddUserId,ActionName,ActionUrl,Atime,ContentOld,ContentNew,TableName,TableId ");
            strSql.Append(" FROM T_Com_LogAction ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" Id,AddUser,AddUserId,ActionName,ActionUrl,Atime,ContentOld,ContentNew,TableName,TableId ");
            strSql.Append(" FROM T_Com_LogAction ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Com_LogAction ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return obj.ToInt32();
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Com_LogAction T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }
        #region
        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Com_LogAction";
			parameters[1].Value = "Id";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/
        #endregion
        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
    public static class LogAciton
    {
        /// <summary>
        /// 
        /// </summary>
        /// <param name="TableName"></param>
        /// <param name="id"></param>
        /// <param name="ActionName"></param>
        /// <param name="oldobj"></param>
        /// <param name="ContentNew">操作记录  敏感信息 主要设置</param>
        /// <returns></returns>
        public static bool AddAction(string UserName, int id, string ActionName, string oldobj = "", string ContentNew = "操作记录",string module1="",string module2="")
        {
            Model.T_Com_LogAction modellog = new Model.T_Com_LogAction();
            modellog.ActionName = ActionName.ToMyString();
            modellog.AddUser = UserName.ToMyString();
            modellog.AddUserId = id;
            modellog.Atime = DateTime.Now;
            modellog.ActionUrl = module1+"-"+ module2;
            modellog.ContentNew = ContentNew.ToMyString();
            modellog.ContentOld = oldobj.ToMyString();
            modellog.TableId = id.ToMyString();
            modellog.TableName = module1+"—"+module2;

            return new T_Com_LogAction().Add(modellog);
        }
    }
}

